clear all;
close all;
lee_archivos = dir('C:\Users\rabargon\Desktop\prueba express\*.jpg'); %el formato de imagen puede ser modificado.

for aa =1 : length(lee_archivos)
    
    i0=1;
    
    archivo = lee_archivos(aa).name; %Obtiene el nombre de los archivos
    nombre = 'C:\Users\rabargon\Desktop\prueba express\'; %Recore el diretorio
    
    Npx = 120;
    
    I = imread(strcat(nombre,archivo));% lee la primera imagen
    
    % I=imread('KDEF Definitva\SU_Sorpresa\AM10SUS.jpg');
    % imshow(I);
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Detecta la cara
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    %Detecta la cara y recorta
    FDetect = vision.CascadeObjectDetector;
    FDetect.MergeThreshold = 8;
    %Returns Bounding Box values based on number of objects
    BB = step(FDetect,I);
    mat_image=cell(1,size(BB,1));
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Recorta la cara
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    for i = 1:size(BB,1)
        mat_image{i}=imcrop(I,BB(i,:));
        mat_image{i} = imresize(mat_image{i}, [Npx,Npx]);
        figure(i)
        imshow(mat_image{i});
        title('Face Detection');
        %hold off
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %% Detecta la nariz, recorta, binariza y guarda
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        NoseDetect = vision.CascadeObjectDetector('Nose','MergeThreshold',16);
        for iN = 1:size(BB,1)
            BBnose=step(NoseDetect,mat_image{i});
            figure(iN);
            hold on
            rectangle('Position',BBnose(1,:),'LineWidth',1.5,'LineStyle','-','EdgeColor','b');
            Nose=imcrop(mat_image{i},BBnose(1,:));
            
        end
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %% Detecta la boca, recorta, binariza y guarda
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        MouthDetect = vision.CascadeObjectDetector('Mouth');
        MouthDetect.MergeThreshold= 20;
        for iM = 1:size(BB,1)
            BBmouth=step(MouthDetect,mat_image{i});
            for jM= 1: size(BBmouth,1)
                if (BBmouth(jM,2) > BBnose(1,2))
                    BBmouth2= [ (BBmouth(:,1)) (BBmouth(:,2)+3) (BBmouth(:,3)) (BBmouth(:,4)-3)];
                    rectangle('Position',BBmouth2(jM,:),'LineWidth',1,'LineStyle','-','EdgeColor','m');
                    title('Mouth Detection');
                    Mouth=imcrop(mat_image{i},BBmouth2(jM,:));
                    H_MouthG = BBmouth2(jM,4);
                    Mouth= rgb2gray(Mouth);
                    F = adaptthresh(Mouth,0.45,'ForegroundPolarity','dark','NeighborhoodSize',29);
                    BW_Mouth = not(imbinarize(Mouth,F));
                    BW_Mouth = bwpropfilt(BW_Mouth,'area', [100 inf]);
                    [L Ne]=bwlabel(BW_Mouth);
                    propied= regionprops(L);
                    b =[propied.BoundingBox];
                    x_Mouth = b(:,1);
                    y_Mouth = b(:,2);
                    H_Mouth = b(:,4);
                    W_Mouth = b(:,3);
                    nombre2 = 'Test\';
                    imwrite(BW_Mouth,[nombre2 'mouth' num2str(iM) '.jpg'],'jpg');
                    imshow(BW_Mouth);
                    
                end
            end
            
        end
        
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Calculo primer punto negro X PUNTO K
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        [HK WK] = find (L == 1);
        
        [WKfirst HKfirst Ki]= find(WK,1,'first');
        [WKfirst2 HKfirst2 Kj]= find(HK,1,'first');
        
        puntoKx = Kj;
        puntoKy = Ki;
        imshow(BW_Mouth);hold on; plot(puntoKx,puntoKy, '+','MarkerSize',10)
        
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Calculo ultimo punto negro X PUNTO L
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        [HL WL] = find (L == 1);
        
        [WLlast HLlast Li]= find(WL,1,'last');
        [WL2 HL2 Lj]= find(HL,1,'last');
        
        puntoLx = Lj;
        puntoLy = Li;
        imshow(BW_Mouth);hold on; plot(puntoLx,puntoLy, '+','MarkerSize',10)
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Calculo distancia punto K-L
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        D6= sqrt(((puntoKx - puntoLx)^2)+((puntoKy - puntoLy)^2));
        
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Calculo primer punto negro Y PUNTO M
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        
        for Mi=1:H_Mouth
            Mj= round(W_Mouth/2);
            if (BW_Mouth(Mi,Mj) == 1)
                puntoMx = Mj;
                puntoMy = Mi;
                imshow(BW_Mouth);hold on; plot(puntoMx,puntoMy, '+','MarkerSize',10)
                break
            end
        end
        
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Calculo ultimo punto negro Y PUNTO O
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        for Oi= 1: H_MouthG
            Oj= round(W_Mouth/2);
            if (BW_Mouth(Oi,Oj) == 1)
                puntoOx = Oj;
                puntoOy = Oi;
                imshow(BW_Mouth);hold on; plot(puntoOx,puntoOy, '+','MarkerSize',10)
            end
        end
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Calculo distancia punto M-O
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        D7= sqrt(((puntoMx - puntoOx)^2)+((puntoMy - puntoOy)^2));
        
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Calculo punto N centro de la boca
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        puntoNx = round(H_Mouth/2);
        puntoNy = round(W_Mouth/2);
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Distancia del punto K-N
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        D8= sqrt(((puntoKx - puntoNx)^2)+((puntoKy - puntoNy)^2));
        
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Distancia del punto N-L
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        D9= sqrt(((puntoNx - puntoLx)^2)+((puntoNy - puntoLy)^2));
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Distancia de la linea recta M-N al centro de la boca
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        
        hc=(1/2)* (sqrt(2*(D9^2 + D8^2) - D6^2)) ;
        D10= hc;
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Deteccion de los dientes
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        F2 = adaptthresh(Mouth,0.45,'ForegroundPolarity','bright','NeighborhoodSize',5);
        BW_Mouth2 = imbinarize(Mouth,F2);
        imshow(BW_Mouth2)
        x_smile = puntoNx+5;
        y_smile = puntoNy+5;
        area_smile=  imcrop (BW_Mouth2,[x_smile y_smile 10 10]);
        [ar Nearea]=bwlabel(area_smile);
        prop= regionprops(ar);
        area=[prop.Area];
        area_smile=sum(area);
        
        if (area_smile >= 1)
            Teeth=1;
        else
            Teeth=0;
        end
        D11= Teeth;
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %% Detecta los ojos y cejas, recorta, binariza y guarda
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        EyeDetect = vision.CascadeObjectDetector('EyePairBig');
        for iE = 1:size(BB,1)
            BBeye=step(EyeDetect,mat_image{i});
            BBeye2 = [(BBeye(:,1)-2) (BBeye(:,2)-10) (BBeye(:,3)) (BBeye(:,4)+10)];
            figure(iE);
            rectangle('Position',BBeye2(1,:),'LineWidth',1.5,'LineStyle','-','EdgeColor','b');
            imshow (BBeye2);
            title('Eye Detection');
            Eye=imcrop(mat_image{i},BBeye2(1,:));
            x_EyeG = BBeye2(:,1);
            y_EyeG = BBeye2(:,2);
            H_EyeG = BBeye2(:,4);
            W_EyeG = BBeye2(:,3);
            
            H_EyeG2 = round(H_EyeG/2);
            W_EyeG2 = round(W_EyeG/2);
            
            Eye= rgb2gray (Eye);
            imshow(Eye);
            T = adaptthresh(Eye,0.45,'ForegroundPolarity','dark','NeighborhoodSize',9);
            BW_Eye = not(imbinarize(Eye,T));
            imshow (BW_Eye);
            
            BW_Eye2 = bwpropfilt(BW_Eye,'area', [30 800]);
            IM2 = bwmorph(BW_Eye2,'thicken');
            IM3 = bwmorph(IM2,'thin');
            imshow (BW_Eye2);
            imshow(IM3);
            nombre2 = 'Test\';
            imwrite(IM3,[nombre2 'Eye' num2str(iE) '.jpg'],'jpg');
            hold off;
        end
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Clculo Ojo Izquierdo
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        
        Left_Eye_section = imcrop (IM3, [1 1 W_EyeG/2 H_EyeG]); % recorto la parte del ojo izquierdo
        imshow (Left_Eye_section)
        
        [L1 Ne1]=bwlabel(Left_Eye_section);
        propied1= regionprops(L1);
        f=[propied1.Centroid];
        f=reshape(f,2,numel(f)/2).';
        [mm,ind]=min(f(:,2));
        
        
        Left_Eye=Left_Eye_section;
        Left_Eye(L1==ind)=0;
        se = strel('line',5,1);
        Left_Eye = imdilate(Left_Eye,se);% Dilate con elemento estructurante linea de 3 pixeles
        [L_L Ne_L]=bwlabel(Left_Eye);
        propied_L= regionprops(L_L);
        
        e_l= [propied_L.BoundingBox];
        e_l=reshape(e_l,4,numel(e_l)/4).';
        [mm_L,ind_L]=min(e_l(:,2));
        
        x_Eye = (e_l(ind_L, 1));
        y_Eye = (e_l(ind_L, 2));
        H_Eye = (e_l(ind_L, 4));
        W_Eye = (e_l(ind_L ,3));
        
        Eyebrow_Left=Left_Eye_section;
        ind0=1:Ne1; ind0(ind0==ind)=[];
        for ii=1:Ne1-1
            Eyebrow_Left(L1==ind0(ii))=0;
        end
        
        eb_l= [propied1.BoundingBox];
        eb_l=reshape(eb_l,4,numel(eb_l)/4).';
        x_EyeBrow = (eb_l(ind, 1));
        y_EyeBrow = (eb_l(ind, 2));
        H_EyeBrow  = (eb_l(ind, 4));
        W_EyeBrow  = (eb_l(ind ,3));
        
        
        
        imshow(Eyebrow_Left);
        imshow (Left_Eye);
        
        
        
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Calculo primer punto negro Y PUNTO C
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        if (isempty(ind0))
            Left_Eye= Eyebrow_Left;
            ind_L=ind;
            L_L = L1;
            H_Eye = H_EyeBrow;
            W_Eye = W_EyeBrow;
            
        end
        
        [HC WC]= find (L_L==ind_L(1));
        
        for Ci=1:H_EyeG
            Cj= (WC(1,1)+round(W_Eye/2));
            if (Left_Eye(Ci,Cj) ==1)
                puntoCx = Cj;
                puntoCy = Ci;
                imshow(Left_Eye);hold on; plot(puntoCx,puntoCy, '+','MarkerSize',10)
                break
            end
        end
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Calculo ultimo punto negro Y PUNTO D
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        
        for Di= 1: H_EyeG
            Dj= (WC(1,1)+ round(W_Eye/2));
            if (Left_Eye(Di,Dj) ==1)
                puntoDx = Dj;
                puntoDy = Di;
                imshow(Left_Eye);hold on; plot(puntoDx,puntoDy, '+','MarkerSize',10)
            end
        end
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Calculo distancia punto C-D
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        D1= sqrt(((puntoCx - puntoDx)^2)+((puntoCy - puntoDy)^2));
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Calculo primer punto negro Y PUNTO A
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        if(Ne1 > 1)
            [HA WA]= find (L1==ind);
            
            for Ai=1:H_EyeG
                Aj= (WA(1,1)+(round(W_EyeBrow/2)));
                if (Eyebrow_Left(Ai,Aj) ==1)
                    puntoAx = Aj;
                    puntoAy = Ai;
                    imshow(Eyebrow_Left);hold on; plot(puntoAx,puntoAy, '+','MarkerSize',10)
                    break
                end
            end
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            % Calculo ultimo punto negro Y PUNTO B
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            for Bi= 1: H_EyeG
                Bj=  (WA(1,1)+(round(W_EyeBrow/2)));
                if (Eyebrow_Left(Bi,Bj) ==1)
                    puntoBx = Bj;
                    puntoBy = Bi;
                    imshow(Eyebrow_Left);hold on; plot(puntoBx,puntoBy, '+','MarkerSize',10)
                end
            end
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            % Calculo Distancia de la ceja al ojo B-C
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            D2= sqrt(((puntoBx - puntoCx)^2)+((puntoBy - puntoCy)^2));
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            % Calculo ultimo punto negro X PUNTO E
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            del = sqrt(((puntoAx-puntoBx)^2)+((puntoAy-puntoBy)^2));
            
            [WA1 HA1 Ei]= find(WA,1,'last');
            [WA2 HA2 Ej]= find(HA,1,'last');
            puntoEx = Ei;
            puntoEy = Ej;
            imshow(Eyebrow_Left);hold on; plot(puntoEx,puntoEy, '+','MarkerSize',10)
        else
            D2=0;
        end
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Clculo Ojo Derecho
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        Right_Eye_section = imcrop(IM3 ,[W_EyeG/2 1 W_EyeG/2 H_EyeG]); % recorto la parte del ojo derecho
        
        [L2 Ne2]=bwlabel(Right_Eye_section);
        propied2= regionprops(L2);
        f2=[propied2.Centroid];
        f2=reshape(f2,2,numel(f2)/2).';
        [mm2,ind2]=min(f2(:,2));
        
        Right_Eye= Right_Eye_section;
        Right_Eye(L2==ind2)=0;
        se = strel('line',5,1);
        Right_Eye = imdilate(Right_Eye,se);
        
        
        [L_R Ne_R]=bwlabel(Right_Eye);
        propied_R= regionprops(L_R);
        
        e_R= [propied_R.BoundingBox];
        e_R=reshape(e_R,4,numel(e_R)/4).';
        [mm_R,ind_R]=min(e_R(:,2));
        
        
        x_Eye_R = (e_R(ind_R, 1));
        y_Eye_R = (e_R(ind_R, 2));
        H_Eye_R = (e_R(ind_R, 4));
        W_Eye_R = (e_R(ind_R ,3));
        
        Eyebrow_Right=Right_Eye_section;
        ind00=1:Ne2; ind00(ind00==ind2)=[];
        for iii=1:Ne2-1
            Eyebrow_Right(L2==ind00(iii))=0;
        end
        
        eb_R= [propied2.BoundingBox];
        eb_R=reshape(eb_R,4,numel(eb_R)/4).';
        x_EyeBrow_R = (eb_R(ind2, 1));
        y_EyeBrow_R = (eb_R(ind2, 2));
        H_EyeBrow_R  = (eb_R(ind2, 4));
        W_EyeBrow_R  = (eb_R(ind2 ,3));
        
        
        imshow(Eyebrow_Right);
        imshow(Right_Eye);
        
        if (ind00 ==0)
            ind00 =1;
            ind_R=1;
        end
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Calculo primer punto negro Y PUNTO H
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        if (isempty(ind00))
            Right_Eye= Eyebrow_Right;
            ind_R=ind2;
            L_R = L2;
            H_Eye_R = H_EyeBrow_R;
            W_Eye_R = W_EyeBrow_R;
            
        end
        
        [HH WH]= find (L_R==ind_R(1));
        
        for Hi=1:H_EyeG
            Hj= (WH(1,1)+round(W_Eye_R/2));
            if (Right_Eye(Hi,Hj)==1)
                puntoHx = Hj;
                puntoHy = Hi;
                imshow(Right_Eye);hold on; plot(puntoHx,puntoHy, '+','MarkerSize',10)
                break
            end
        end
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Calculo ultimo punto negro Y PUNTO I
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        for Ii= 1: H_EyeG
            Ij= (WH(1,1)+round(W_Eye_R/2));
            if (Right_Eye(Ii,Ij) ==1)
                puntoIx = Ij;
                puntoIy = Ii;
                imshow(Right_Eye);hold on; plot(puntoIx,puntoIy, '+','MarkerSize',10)
            end
        end
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Calculo distancia punto H-I
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        D3= sqrt(((puntoHx - puntoIx)^2)+((puntoHy - puntoIy)^2));
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Calculo primer punto negro Y PUNTO F
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        if (Ne2 > 1)
            [HF WF] = find (L2== ind2);
            
            for Fi=1:H_EyeG
                Fj= (WF(1,1) + (round(W_EyeBrow_R/2)));
                if (Eyebrow_Right(Fi,Fj) ==1)
                    puntoFx = Fj;
                    puntoFy = Fi;
                    imshow(Eyebrow_Right);hold on; plot(puntoFx,puntoFy, '+','MarkerSize',10)
                    break
                end
            end
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            % Calculo ultimo punto negro Y PUNTO G
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            for Gi= 1: H_EyeG
                Gj= (WF(1,1)+(round(W_EyeBrow_R/2)));
                if (Eyebrow_Right(Gi,Gj) == 1)
                    puntoGx = Gj;
                    puntoGy = Gi;
                    imshow(Eyebrow_Right);hold on; plot(puntoGx,puntoGy, '+','MarkerSize',10)
                end
            end
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            % Calculo Distancia de la ceja al ojo G-H
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            
            D4= sqrt(((puntoGx - puntoHx)^2)+((puntoGy - puntoHy)^2));
            
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            % Calculo Primer punto negro X PUNTO J
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            der = sqrt(((puntoFx-puntoGx)^2)+((puntoFy-puntoGy)^2));
            
            [WJ1 HJ1 Ji]= find(WF,1,'first');
            [WJ2 HJ2 Jj]= find(HF,1,'first');
            puntoJx = Ji;
            puntoJy = Jj;
            imshow(Eyebrow_Right);hold on; plot(puntoJx,puntoJy, '+','MarkerSize',10)
        else
            D4=0;
        end
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Calculo Distancia entre cejas E-J
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        if (D2 == 0)
            [WEb HEb Ei] = find (WC, 1, 'last');
            [WEb2 HEb2 Ej] =find (HC, 1, 'last');
            
            [WJb HJb Ji] = find (WH, 1, 'first');
            [WJb2 HJb2 Jj] =find (WH, 1, 'first');
            
            puntoEx = Ei;
            puntoEy = Ej;
            puntoJx = Ji;
            puntoJy = Jj;
            D5= sqrt(((puntoEx - puntoJx)^2)+((puntoEy - puntoJy)^2));
            
            Average = (D2+D4)/2;
        else if ((D2 ~= 0)&& (D4== 0))
                D4=D2;
                Average = (D2+D4)/2;
                
            else
                D5= sqrt(((puntoEx - puntoJx)^2)+((puntoEy - puntoJy)^2));
                
                Average = (D2+D4)/2;
            end
        end
    end
    Dis_Input(:,aa) = [ D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 Average ];
    %Name (:,aa)=[archivo];
    
    save('Dis_Input.txt', 'Dis_Input', '-ascii');
    
    %save('Name_In.txt', 'Name', '-ascii');
    
    
    %     archivo0=archivo(1:end-4);% eliminamos las 4 ultimos caracteres del nombre de la imagen el .jpg para no sobreescribirlo
    %
    %         nombre2 = 'D:\Raquel\Universidad\TFG\pruebas matlab\Imagenes AF_Miedo\';
    %         B= (strcat(nombre2,archivo0));
    %         imwrite(Eyebrow_Left,[B '_' num2str(1) '.jpg'],'jpg');
    %         imwrite(Eyebrow_Right,[B '_' num2str(2) '.jpg'],'jpg');
    %         imwrite(Left_Eye,[B '_' num2str(3) '.jpg'],'jpg');
    %         imwrite(Right_Eye,[B '_' num2str(4) '.jpg'],'jpg');
    %         imwrite(BW_Mouth,[B '_' num2str(5) '.jpg'],'jpg');
    %
end

    